/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package webshop.controller;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import webshop.model.Customer;
import webshop.model.Item;
import webshop.model.Order;
import webshop.storage.CustomerStorage;
import webshop.storage.ItemStorage;
import webshop.storage.OrderStorage;

/**
 *
 * @author emsi
 */
public class PurchasingController extends HttpServlet {

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        ServletContext sc = this.getServletContext();
        RequestDispatcher rd =
                sc.getRequestDispatcher("/WEB-INF/purchase.jsp");
        rd.forward(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession();

        String name = request.getParameter("name");
        String firstName = request.getParameter("firstName");
        String email = request.getParameter("email");

        Customer customer = new Customer();
        customer.setName(name);
        customer.setFirstName(firstName);
        customer.setEmail(email);
        
        Map<Integer, Integer> cart = (Map<Integer, Integer>) session.getAttribute("cart");
        if (cart == null) {
            throw new RuntimeException("you need to add items to your shopping cart");
        }
        ItemStorage itemStorage = new ItemStorage(this.getServletContext());
        List<Item> items = itemStorage.read();
        boolean tooManyItems = false;
        for (Item item : items) {
            if (cart.containsKey(item.getId()) && item.getInventory() < cart.get(item.getId())) {
                cart.put(item.getId(), item.getInventory());
                tooManyItems = true;
            }
        }
        if (tooManyItems) {
            response.sendRedirect("/cart?error=overflow");
            return;
        }
        
        CustomerStorage customerStorage = new CustomerStorage(this.getServletContext());
        int customerId = customerStorage.create(customer);
        
        Order order = new Order();
        order.setCustomerId(customerId);
        order.setCart(cart);
        OrderStorage orderStorage = new OrderStorage(this.getServletContext());
        int orderId = orderStorage.create(order);
        
        session.setAttribute("cart", new HashMap<Integer, Integer>());
        
        response.sendRedirect("/purchase");
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
