/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package webshop.controller;

import webshop.model.Item;
import java.io.IOException;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import webshop.storage.ItemStorage;

/**
 *
 * @author dienert
 */
public class ShopController extends HttpServlet { 
    
    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
        try {
            response.setContentType("text/html;charset=UTF-8");
            HttpSession session = request.getSession();
            
            ItemStorage itemStorage = new ItemStorage(this.getServletContext());
            List<Item> items = itemStorage.read();
            Set<String> brands = new HashSet<String>();
            Iterator<Item> iterator = items.iterator();
            while (iterator.hasNext()) {
                Item item = iterator.next();
                brands.add(item.getBrand());
                
                // brand filtering
                String brandParam = request.getParameter("brand");
                if (
                    brandParam != null 
                    && !brandParam.isEmpty() 
                    && !item.getBrand().equals(brandParam)
                ) {
                    iterator.remove();
                    continue;
                }
                
                // search filtering
                String searchParam = request.getParameter("search");
                if (
                    searchParam != null
                    && !searchParam.isEmpty()
                ) {
                    if (!item.getName().toLowerCase().contains(searchParam.toLowerCase())) {
                        iterator.remove();
                        continue;
                    } else {
                        String newItemName = item.getName();
                        newItemName = newItemName.replaceAll(
                            "(?i)" + searchParam, 
                            "<span class=\"highlight\">" + searchParam + "</span>");
                        item.setName(newItemName);
                    }
                }
                
                // adjust description length
                item.setDescription(item.getDescription().substring(0, 50) + "...");
            }
            session.setAttribute("items", items);
            session.setAttribute("brands", brands);
            
            ServletContext sc =
                    this.getServletContext();
            RequestDispatcher rd =
                    sc.getRequestDispatcher("/WEB-INF/index.jsp");
            rd.forward(request, response);
        } catch (Exception ex) {
            Logger.getLogger(ShopController.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
