/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package webshop.storage;

import generated.Items.Row;
import java.io.File;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletContext;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import webshop.model.Item;

/**
 *
 * @author emsi
 */
public class ItemStorage implements Storage<Item> {
    
    private JAXBContext context;
    private ServletContext servletContext;
    
    
    public ItemStorage(ServletContext servletContext) {
        this.servletContext = servletContext;
        try {
            this.context = JAXBContext.newInstance(generated.Items.class);
        } catch (JAXBException ex) {
            Logger.getLogger(ItemStorage.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Override
    public int create(Item o) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public List<Item> read() {
        List<Item> items = new ArrayList();
        try {            
            Unmarshaller unmarshaller = this.context.createUnmarshaller();
            generated.Items itemsResult = (generated.Items) unmarshaller.unmarshal(
                new File(this.servletContext.getResource("WEB-INF/xml/items.xml").getPath()
            ));
            
            for (Row row : itemsResult.getRow()) {
                Item item = new Item();
                item.setBrand(row.getBrand());
                item.setDescription(row.getDescription());
                item.setId(row.getId());
                item.setImage(row.getImage());
                item.setInventory(row.getInventory());
                item.setName(row.getName());
                item.setPrice(row.getPrice());
                
                items.add(item);
            }
            
            return items;
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }
    
    @Override
    public Item read(int id) {
        List<Item> items = read();
        for (Item current : items) {
            if (current.getId() == id) {
                return current;
            }
        }
        throw new RuntimeException();
    }

    @Override
    public boolean update(Item o) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean delete(int id) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    private Item fromResultSet(ResultSet resultSet) {
        try {
            Item item = new Item();
            item.setId(Integer.parseInt(resultSet.getString(1)));
            item.setName(resultSet.getString(2));
            item.setDescription(resultSet.getString(3));
            item.setImage(resultSet.getString(4));
            item.setPrice(Double.parseDouble(resultSet.getString(5)));
            item.setBrand(resultSet.getString(6));
            item.setInventory(Integer.parseInt(resultSet.getString(7)));

            return item;
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
    
}
