/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package webshop.storage;

import generated.Items;
import generated.ItemsOrders;
import javax.xml.datatype.DatatypeFactory;
import generated.Orders.Row;
import java.io.File;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Map.Entry;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import webshop.model.Order;
import java.util.Random;
import javax.servlet.ServletContext;

/**
 *
 * @author emsi
 */
public class OrderStorage implements Storage<Order> {

    private JAXBContext context;
    private ServletContext servletContext;
    
    public OrderStorage(ServletContext servletContext) {
        this.servletContext = servletContext;
    }
    
    @Override
    public int create(Order order) {
        try {
            // create order
            this.context = JAXBContext.newInstance(generated.Orders.class);
            String fileLocation = "WEB-INF/xml/orders.xml";
            Marshaller marshaller = this.context.createMarshaller();
            Unmarshaller unmarshaller = this.context.createUnmarshaller();
            generated.Orders ordersResult = (generated.Orders) unmarshaller.unmarshal(
                new File(this.servletContext.getResource(fileLocation).getPath())
            );
            
            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            
            Row row = new Row();
            row.setCustomerId(order.getCustomerId());
            row.setDate(DatatypeFactory.newInstance().newXMLGregorianCalendar(new GregorianCalendar()));
            order.setId(new Random().nextInt());
            row.setId(order.getId());
            
            ordersResult.getRow().add(row);
            
            marshaller.marshal(ordersResult, new File(this.servletContext.getResource(fileLocation).getPath()));
            
            // create items to order relation
            this.context = JAXBContext.newInstance(generated.ItemsOrders.class);
            fileLocation = "WEB-INF/xml/items_orders.xml";
            marshaller = this.context.createMarshaller();
            unmarshaller = this.context.createUnmarshaller();
            generated.ItemsOrders itemsOrdersResult = (generated.ItemsOrders) unmarshaller.unmarshal(
                new File(this.servletContext.getResource(fileLocation).getPath())
            );
            
            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            for (Entry<Integer, Integer> entry : order.getCart().entrySet()) {
                for (int i = 0; i < entry.getValue(); i++) {
                    ItemsOrders.Row itemOrdersRow = new ItemsOrders.Row();
                    itemOrdersRow.setItemId(entry.getKey());
                    itemOrdersRow.setOrderId(order.getId());
                    
                    itemsOrdersResult.getRow().add(itemOrdersRow);
                }                
            }
            
            marshaller.marshal(itemsOrdersResult, new File(this.servletContext.getResource(fileLocation).getPath()));
            
            // reduce inventory
            this.context = JAXBContext.newInstance(generated.Items.class);
            fileLocation = "WEB-INF/xml/items.xml";
            marshaller = this.context.createMarshaller();
            unmarshaller = this.context.createUnmarshaller();
            generated.Items itemsResult = (generated.Items) unmarshaller.unmarshal(
                new File(this.servletContext.getResource(fileLocation).getPath())
            );
            
            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            for (Entry<Integer, Integer> entry : order.getCart().entrySet()) {
                for (Items.Row currentRow : itemsResult.getRow()) {
                    if (currentRow.getId() != entry.getKey()) {
                        continue;
                    }
                    currentRow.setInventory(currentRow.getInventory() - entry.getValue());
                }             
            }
            
            marshaller.marshal(itemsResult, new File(this.servletContext.getResource(fileLocation).getPath()));
            
            
            return order.getId();
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }

    @Override
    public List<Order> read() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Order read(int id) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean update(Order o) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean delete(int id) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
