<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
        <link rel="stylesheet" href="style.css">
        <title>eMSi's webshop</title>
    </head>
    <body>
        <div class="header">
            <div class="text">
                <a href="/shop">
                    SARG SCOUT 24
                </a>
                <a href="/cart" class="cart-icon">
                    <i class="material-icons">shopping_cart</i>
                </a>
            </div>
        </div>
        <div class="brand-selector">
            <div class="content">
                Marke auswählen: <a href="/shop">Alle</a>
                <c:forEach items="${brands}" var="brand">
                    <c:choose>
                        <c:when test="${param.brand == brand}">
                            <a href="?brand=${brand}" class="active">${brand}</a>
                        </c:when>
                        <c:otherwise>
                            <a href="?brand=${brand}">${brand}</a>
                        </c:otherwise>
                    </c:choose>
                </c:forEach>
                <form method="GET" action="">
                    <input type="text" name="search" value="${param.search}"/>
                    <button type="submit">Suchen</button>
                </form>
            </div>
        </div>
        <c:forEach items="${items}" var="item">
            <table class="item">
                <tr>
                    <td class="image"></td>
                    <td class="name">
                        <a href="detail?id=${item.id}">${item.name}</a>
                    </td>
                    <td class="buying" rowspan="2">
                        <div class="price">
                            <fmt:formatNumber value="${item.price}" type="currency"/>
                        </div>
                        <div class="inventory">
                            Noch ${item.inventory} Stück auf Lager
                        </div>
                        <form method="POST" action="cart">
                            <input type="number" name="amount" value="1" min="1" max="${item.inventory}"/><br />
                            <input type="hidden" name="id" value="${item.id}" />
                            <button tpye="submit">In den Warenkorb</button>
                        </form>
                    </td>
                </tr>
                <tr>
                    <td class="image">
                        <img src="${item.image}"/>
                    </td>
                    <td class="description">
                        ${item.description}<br /><br />
                        Hersteller: ${item.brand}
                    </td>
                </tr>
            </table>
        </c:forEach>
        <c:if test="${items.size() == 0}">
            <table class="item">
                <tr>
                    <td>
                        Keine Einträge vorhanden
                    </td>
                </tr>
            </table>
        </c:if>
    </body>
</html>
