<%-- 
    Document   : shopping-cart
    Created on : 16.04.2016, 12:04:06
    Author     : emsi
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" href="style.css">
        <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
        <title>Einkaufswagen</title>
    </head>
    <body>
        <div class="header">
            <div class="text">
                <a href="/shop">
                    SARG SCOUT 24
                </a>
                <a href="/cart" class="cart-icon">
                    <i class="material-icons">shopping_cart</i>
                </a>
            </div>
        </div>
        <c:set var="total" scope="page" value="0"/>
        <h1>Warenkorb</h1>
        <c:if test="${param.error == 'overflow'}">
            <div class="error">
                Es sind nicht genügend Särge vorrätig. Ihre Menge wurde angepasst. Bitte überprüfen Sie ihren Warenkorb
            </div>
        </c:if>
        <c:forEach var="entry" items="${cart}">
            <table class="cart">
                <tr>
                    <td class="image">
                        <img src="${items[(entry.key)].image}"/>
                    </td>
                    <td class="name">
                        ${items[(entry.key)].name}
                    </td>
                    <td class="price">
                        ${entry.value} Stück a 
                        <fmt:formatNumber value="${items[(entry.key)].price}" type="currency"/> =
                        <fmt:formatNumber value="${entry.value * items[(entry.key)].price}" type="currency"/>
                        
                        <c:set var="total" scope="page" value="${total + entry.value * items[(entry.key)].price}"/>
                    </td>
                    <td class="delete">
                        <form method="POST" action="deleteItem">
                            <input type="hidden" name="id" value="${entry.key}"/>
                            <button type="submit">X</button>
                        </form>
                    </td>
                </tr>
            </table>
        </c:forEach>
        
        <table class="cart">
            <tr>
                <td class="summary">
                    Gesamt:
                    <fmt:formatNumber value="${total}" type="currency"/>
                </td>
            </tr>
        </table>
        
        <a href="/shop" class="button">Weiter Einkaufen</a>
        
        <c:if test="${cart.size() != 0}">
            <form method="POST" action="purchase" class="buy">
                <label for="name">Name</label>
                <input type="text" name="name" required/><br />
                <label for="firstName">Vorname</label>
                <input type="text" name="firstName" required/><br />
                <label for="email">E-Mail</label>
                <input type="email" name="email" required/><br />
                <button type="submit">Bestellen</button>
            </form>
        </c:if>
    </body>
</html>
